'*********************************************************************
'*  CAL.BAS by Arnold Trembley, Wed-23-May-2012
'*  a simulation of the CAL.EXE utility from Unix/Linux
'*  for 64-Bit Windows 7 command line execution.
'*  Revised Thu-08-Feb-2018
'*********************************************************************
#COMPILE EXE              '* Create an EXE program
#COMPILER PBCC            '* PowerBasic Classic Console Compiler V4.06
#DIM ALL                  '* ALLOCATE ALL VARIABLES BEFORE USE
#DEBUG ERROR ON

FUNCTION PBMAIN () AS LONG

'*********************************************************************
'*  DEFINE VARIABLES HERE/ALLOCATE UNINITIALIZED VARIABLES
'*********************************************************************

DIM EYECATCHER AS STRING  '* TO IDENTIFY THE SOURCE FILE
DIM PARMLIST AS STRING    '* TO RECEIVE COMMAND LINE ARGUMENTS
DIM CURRDATE AS STRING    '* TO RECEIVE CURRENT DATE
DIM SHOWYEAR AS STRING    '* TO HOLD THE CURRENT YEAR DEFAULT
DIM CURRYEAR&             '* TO RECEIVE CURRENT YEAR
DIM CURRMONTH&            '* TO RECEIVE CURRENT MONTH
DIM PARMCOUNT&            '* TO RECEIVE COUNT OF COMMAND LINE ARGUMENTS
DIM PARMLNTH&             '* TO RECIEVE THE LENGTH OF THE COMMAND LINE STRING
DIM I AS LONG             '* GENERIC SUBSCRIPT
DIM J AS LONG             '* Another Generic subscript
DIM K AS LONG             '* SUBSCRIPT FOR FULL YEAR CALENDAR
DIM RETURNCODE AS LONG    '* To receive returncode from subroutines
DIM DAYSUB AS LONG        '* to receive day of week subscript
DIM CALPARM1 AS LONG      '* CALENDAR PARAMETER 1 (MONTH FOR MONTH & YEAR, OR YEAR)
DIM CALPARM2 AS LONG      '* CALENDAR PARAMETER 2 (YEAR FOR MONTH & YEAR)
DIM MONTHSIZE&            '* NUMBER OF DAYS IN THE MONTH
DIM CALENDAR AS STRING    '* WORKAREA TO HOLD THE CALENDAR, 126 BYTES LONG

DIM YEARMONTH(1 TO 12) AS STRING   '* TO HOLD ENTIRE YEAR CALENDAR
DIM PRINTLINE AS STRING            '* TO HOLD YEARLY CALENDAR HEADERS

'*********************************************************************
'*  INITIALIZE VARIABLES AT PROGRAM START
'*********************************************************************

LET EYECATCHER ="CAL.BAS by Arnold J. Trembley, Thu-08-Feb-2018, PowerBasic V4.06"
CURRDATE = "02-08-2018"

DIM MONTHNAME(1 TO 12) AS STRING
MONTHNAME(1) = "January"
MONTHNAME(2) = "February"
MONTHNAME(3) = "March"
MONTHNAME(4) = "April"
MONTHNAME(5) = "May"
MONTHNAME(6) = "June"
MONTHNAME(7) = "July"
MONTHNAME(8) = "August"
MONTHNAME(9) = "September"
MONTHNAME(10) = "October"
MONTHNAME(11) = "November"
MONTHNAME(12) = "December"
DIM monthheader AS STRING
DIM namelnth AS LONG
DIM nameoffset AS LONG

'*********************************************************************
'*  GET COMMAND LINE ARGUMENTS
'*********************************************************************

PARMLIST = LTRIM$(COMMAND$)
FOR K = 1 TO (LEN(COMMAND$) - 1 )
    REPLACE "  " WITH " " IN PARMLIST  '* Remove Excess Spaces
NEXT
'* debug here
'* PRINT "COMMAND$ = ["; COMMAND$; "]"
'* PRINT "PARMLIST = ["; PARMLIST; "]"

PARMCOUNT& = PARSECOUNT(PARMLIST,ANY " ,;")
PARMLNTH& = LEN(PARMLIST)
DIM MYARG(1 TO PARMCOUNT&) AS STRING
PARSE PARMLIST, MYARG(), ANY " ,;"

'* Print "["; myarg(1); "]"; " ["; myarg(2); "]"

    CALL EDITPARMS(MYARG(1),MYARG(2),RETURNCODE)
    IF RETURNCODE = -1 THEN
        IF LEN(MYARG(2)) = 0 THEN
            PRINT "Year must be in the range 1753 to 3999, not " MYARG(1)
        ELSE
            PRINT "Month must be in the range 1 to 12, not " MYARG(1)
        END IF
        EXIT FUNCTION
    ELSEIF RETURNCODE = -2 THEN
        PRINT "Year must be in the range 1753 to 3999, not " MYARG(2)
        PBMAIN = ABS(RETURNCODE)
        EXIT FUNCTION
    ELSEIF RETURNCODE = -3 THEN
        CALL PrintHelp(RETURNCODE)
        PBMAIN = 0
        EXIT FUNCTION
    ELSEIF RETURNCODE = -4 THEN
        CALL PrintVersion(EYECATCHER,RETURNCODE)
        PBMAIN = 0
        EXIT FUNCTION
    END IF

    CURRDATE = DATE$
    SHOWYEAR = MID$(CURRDATE,7,4)
    CURRYEAR = VAL(MID$(CURRDATE,7,4))
    CURRMONTH = VAL(MID$(CURRDATE,1,2))
'*********************************************************************
'*  DEFAULT TO CURRENT MONTH/YEAR IF NO COMMAND LINE ARGUMENTS
'*********************************************************************
    IF LEN(MYARG(1)) = 0 AND LEN(MYARG(2)) = 0 THEN
        CALPARM1 = CURRMONTH
        CALPARM2 = CURRYEAR
    ELSE
        CALPARM1 = VAL(MYARG(1))
        CALPARM2 = VAL(MYARG(2))
        SHOWYEAR = TRIM$(STR$(CALPARM2))
    END IF

'*********************************************************************
'*  PRINT A CALENDAR FOR THE REQUESTED MONTH AND YEAR
'*********************************************************************
    IF CALPARM1 < 13 THEN
        CALL DAYSINMONTH (CALPARM2, CALPARM1, MONTHSIZE&)
        CALL DAYOFWEEK(CALPARM2,CALPARM1,1,DAYSUB)
        '* PRINT "There are" MONTHSIZE& "days in the month of " MONTHNAME(CALPARM1) "," CALPARM2
        '* Build the month/year CALENDAR header line
        '* and adjust for the variable length of the month name
        NAMELNTH = LEN(MONTHNAME(CALPARM1))
        NAMEOFFSET = 20 - (namelnth + 5)
        NAMEOFFSET = INT(nameoffset / 2) + 1
        'PRINT "NAMEOFFSET =" NAMEOFFSET "  NAMELNTH =" NAMELNTH
        MONTHHEADER = SPACE$(20)
        MID$(MONTHHEADER,NAMEOFFSET,NAMELNTH) = MONTHNAME(CALPARM1)
        MID$(MONTHHEADER,NAMEOFFSET + NAMELNTH + 1,4) = SHOWYEAR
        STDOUT " "
        STDOUT MONTHHEADER
        STDOUT " S  M Tu  W Th  F  S"
        '* Now build the CALENDAR as a long string
        CALENDAR = SPACE$(126)
        '* calculate the starting position
        I = (DAYSUB * 3)
        J = 1
        DO WHILE J <= MONTHSIZE&
            MID$(CALENDAR,I,3) = FORMAT$(J,"## ")
            J = J + 1
            IF J = 10 THEN
                I = I - 1
            END IF
            I = I + 3
        LOOP
        STDOUT MID$(calendar,2,20)
        STDOUT MID$(calendar,23,20)
        STDOUT MID$(calendar,44,20)
        STDOUT MID$(calendar,65,20)
        STDOUT MID$(calendar,86,20)
        STDOUT MID$(calendar,107,20)
        STDOUT " ";

    ELSE

'*********************************************************************
'*  PRINT A CALENDAR FOR THE ENTIRE REQUESTED YEAR
'*********************************************************************
        CALPARM2 = CALPARM1
        FOR K = 1 TO 12
            YEARMONTH (K) = SPACE$(126)
            CALL DAYSINMONTH (CALPARM2, K, MONTHSIZE&)
            CALL DAYOFWEEK(CALPARM2,K,1,DAYSUB)
            I = (DAYSUB * 3)
            J = 1
            DO WHILE J <= MONTHSIZE&
                MID$(YEARMONTH(K),I,3) = FORMAT$(J,"## ")
                J = J + 1
                IF J = 10 THEN
                    I = I - 1
                END IF
                I = I + 3
            LOOP
        NEXT
        'PRINTLINE = SPACE$(39)
        'MID$(PRINTLINE,33,4) = MYARG(1)
        PRINTLINE=SPACE$(32)+MYARG(1)  '* PUT THE YEAR IN THE FIRST LINE
        FOR K = 1 TO 3
            STDOUT " "
        NEXT K
        STDOUT PRINTLINE
        STDOUT " "
        STDOUT "         Jan                    Feb                    Mar "
        STDOUT " S  M Tu  W Th  F  S    S  M Tu  W Th  F  S    S  M Tu  W Th  F  S"
        PRINTLINE=MID$(YEARMONTH(1),2,20)+SPACE$(3)+MID$(YEARMONTH(2),2,20)+SPACE$(3)+MID$(YEARMONTH(3),2,20)
        STDOUT PRINTLINE
        PRINTLINE=MID$(YEARMONTH(1),23,20)+SPACE$(3)+MID$(YEARMONTH(2),23,20)+SPACE$(3)+MID$(YEARMONTH(3),23,20)
        STDOUT PRINTLINE
        PRINTLINE=MID$(YEARMONTH(1),44,20)+SPACE$(3)+MID$(YEARMONTH(2),44,20)+SPACE$(3)+MID$(YEARMONTH(3),44,20)
        STDOUT PRINTLINE
        PRINTLINE=MID$(YEARMONTH(1),65,20)+SPACE$(3)+MID$(YEARMONTH(2),65,20)+SPACE$(3)+MID$(YEARMONTH(3),65,20)
        STDOUT PRINTLINE
        PRINTLINE=MID$(YEARMONTH(1),86,20)+SPACE$(3)+MID$(YEARMONTH(2),86,20)+SPACE$(3)+MID$(YEARMONTH(3),86,20)
        STDOUT PRINTLINE
        PRINTLINE=MID$(YEARMONTH(1),107,20)+SPACE$(3)+MID$(YEARMONTH(2),107,20)+SPACE$(3)+MID$(YEARMONTH(3),107,20)
        STDOUT PRINTLINE
        STDOUT "         Apr                    May                    Jun "
        STDOUT " S  M Tu  W Th  F  S    S  M Tu  W Th  F  S    S  M Tu  W Th  F  S"
        PRINTLINE=MID$(YEARMONTH(4),2,20)+SPACE$(3)+MID$(YEARMONTH(5),2,20)+SPACE$(3)+MID$(YEARMONTH(6),2,20)
        STDOUT PRINTLINE
        PRINTLINE=MID$(YEARMONTH(4),23,20)+SPACE$(3)+MID$(YEARMONTH(5),23,20)+SPACE$(3)+MID$(YEARMONTH(6),23,20)
        STDOUT PRINTLINE
        PRINTLINE=MID$(YEARMONTH(4),44,20)+SPACE$(3)+MID$(YEARMONTH(5),44,20)+SPACE$(3)+MID$(YEARMONTH(6),44,20)
        STDOUT PRINTLINE
        PRINTLINE=MID$(YEARMONTH(4),65,20)+SPACE$(3)+MID$(YEARMONTH(5),65,20)+SPACE$(3)+MID$(YEARMONTH(6),65,20)
        STDOUT PRINTLINE
        PRINTLINE=MID$(YEARMONTH(4),86,20)+SPACE$(3)+MID$(YEARMONTH(5),86,20)+SPACE$(3)+MID$(YEARMONTH(6),86,20)
        STDOUT PRINTLINE
        PRINTLINE=MID$(YEARMONTH(4),107,20)+SPACE$(3)+MID$(YEARMONTH(5),107,20)+SPACE$(3)+MID$(YEARMONTH(6),107,20)
        STDOUT PRINTLINE
        STDOUT "         Jul                    Aug                    Sep "
        STDOUT " S  M Tu  W Th  F  S    S  M Tu  W Th  F  S    S  M Tu  W Th  F  S"
        PRINTLINE=MID$(YEARMONTH(7),2,20)+SPACE$(3)+MID$(YEARMONTH(8),2,20)+SPACE$(3)+MID$(YEARMONTH(9),2,20)
        STDOUT PRINTLINE
        PRINTLINE=MID$(YEARMONTH(7),23,20)+SPACE$(3)+MID$(YEARMONTH(8),23,20)+SPACE$(3)+MID$(YEARMONTH(9),23,20)
        STDOUT PRINTLINE
        PRINTLINE=MID$(YEARMONTH(7),44,20)+SPACE$(3)+MID$(YEARMONTH(8),44,20)+SPACE$(3)+MID$(YEARMONTH(9),44,20)
        STDOUT PRINTLINE
        PRINTLINE=MID$(YEARMONTH(7),65,20)+SPACE$(3)+MID$(YEARMONTH(8),65,20)+SPACE$(3)+MID$(YEARMONTH(9),65,20)
        STDOUT PRINTLINE
        PRINTLINE=MID$(YEARMONTH(7),86,20)+SPACE$(3)+MID$(YEARMONTH(8),86,20)+SPACE$(3)+MID$(YEARMONTH(9),86,20)
        STDOUT PRINTLINE
        PRINTLINE=MID$(YEARMONTH(7),107,20)+SPACE$(3)+MID$(YEARMONTH(8),107,20)+SPACE$(3)+MID$(YEARMONTH(9),107,20)
        STDOUT PRINTLINE
        STDOUT "         Oct                    Nov                    Dec "
        STDOUT " S  M Tu  W Th  F  S    S  M Tu  W Th  F  S    S  M Tu  W Th  F  S"
        PRINTLINE=MID$(YEARMONTH(10),2,20)+SPACE$(3)+MID$(YEARMONTH(11),2,20)+SPACE$(3)+MID$(YEARMONTH(12),2,20)
        STDOUT PRINTLINE
        PRINTLINE=MID$(YEARMONTH(10),23,20)+SPACE$(3)+MID$(YEARMONTH(11),23,20)+SPACE$(3)+MID$(YEARMONTH(12),23,20)
        STDOUT PRINTLINE
        PRINTLINE=MID$(YEARMONTH(10),44,20)+SPACE$(3)+MID$(YEARMONTH(11),44,20)+SPACE$(3)+MID$(YEARMONTH(12),44,20)
        STDOUT PRINTLINE
        PRINTLINE=MID$(YEARMONTH(10),65,20)+SPACE$(3)+MID$(YEARMONTH(11),65,20)+SPACE$(3)+MID$(YEARMONTH(12),65,20)
        STDOUT PRINTLINE
        PRINTLINE=MID$(YEARMONTH(10),86,20)+SPACE$(3)+MID$(YEARMONTH(11),86,20)+SPACE$(3)+MID$(YEARMONTH(12),86,20)
        STDOUT PRINTLINE
        PRINTLINE=MID$(YEARMONTH(10),107,20)+SPACE$(3)+MID$(YEARMONTH(11),107,20)+SPACE$(3)+MID$(YEARMONTH(12),107,20)
        STDOUT PRINTLINE
        STDOUT " ";
    END IF

END FUNCTION

'*********************************************************************
'*  EDIT THE COMMAND LINE ARGUMENTS
'*********************************************************************
SUB EDITPARMS(CMDPARM1$,CMDPARM2$,RC&)
    DIM J AS LONG
    DIM NUM1 AS LONG
    DIM NUM2 AS LONG
    RC& = 0
    NUM1 = 0
    NUM2 = 0

    IF LEFT$(LCASE$(CMDPARM1$),1) = "?"  OR LEFT$(LCASE$(CMDPARM1$),2) = "/?" _
    OR LEFT$(LCASE$(CMDPARM1$),2) = "-?" OR LEFT$(LCASE$(CMDPARM1$),4) = "help" _
    OR LEFT$(LCASE$(CMDPARM1$),6) = "--help" THEN
        RC& = -3    '* Display Help
    END IF

    IF LEFT$(LCASE$(CMDPARM1$),2) = "/v"  OR LEFT$(LCASE$(CMDPARM1$),2) = "-v" _
    OR LEFT$(LCASE$(CMDPARM1$),7) = "version" _
    OR LEFT$(LCASE$(CMDPARM1$),9) = "--version" THEN
        RC& = -4    '* Display Version Information
    END IF

    IF LEN(CMDPARM1$) > 0 AND RC& = 0 THEN
        FOR J = 1 TO LEN(CMDPARM1$)
            'Check for non-numeric characters in CMDPARM1$
            IF ASC(CMDPARM1$,J) < 48 OR ASC(CMDPARM1$,J) > 57 THEN
                RC& = -1
            END IF
        NEXT J
    END IF

    IF LEN(CMDPARM2$) > 0 AND RC& = 0 THEN
        FOR J = 1 TO LEN(CMDPARM2$)
            'Check for non-numeric characters in CMDPARM2$
            IF ASC(CMDPARM2$,J) < 48 OR ASC(CMDPARM2$,J) > 57 THEN
                RC& = -2
            END IF
        NEXT J
    END IF
    '* PRINT "EDITPARMS " CMDPARM2$ " " RC&

    IF LEN(CMDPARM2$) > 0 AND RC& = 0 THEN
        NUM2 = VAL(CMDPARM2$)
        '* check CMDPARM2$ for any year outside the supported range
        IF (NUM2 < 1753 OR NUM2 > 3999) THEN
            RC& = -2
        END IF
    END IF

    IF LEN(CMDPARM1$) > 0 AND RC& = 0 THEN
        NUM1 = VAL(CMDPARM1$)
        '* check CMDPARM1$ for any year outside the supported range
        IF LEN(CMDPARM2$) = 0 THEN  '* only a year was entered
            IF NUM1 < 1753 OR NUM1 > 3999 THEN
                RC& = -1
            END IF
        ELSE
            '* check CMDPARM1$ for valid month
            IF NUM1 < 1 OR NUM1 > 12 THEN
                RC& = -1
            END IF
        END IF
    END IF

END SUB


'*********************************************************************
'*  DETERMINE THE NUMBER OF DAYS IN THE MONTH TO BE PRINTED
'*********************************************************************
SUB DAYSINMONTH(YEAR&,MONTH&,DAYS&)
    DIM MONTHSIZE(1 TO 12) AS LONG
    MONTHSIZE(1) = 31
    MONTHSIZE(2) = 28
    MONTHSIZE(3) = 31
    MONTHSIZE(4) = 30
    MONTHSIZE(5) = 31
    MONTHSIZE(6) = 30
    MONTHSIZE(7) = 31
    MONTHSIZE(8) = 31
    MONTHSIZE(9) = 30
    MONTHSIZE(10) = 31
    MONTHSIZE(11) = 30
    MONTHSIZE(12) = 31
    DIM MOD400&
    DIM MOD100&
    DIM MOD4&

    DAYS& = MONTHSIZE(MONTH&)

        IF MONTH& = 2 THEN
            MOD400& = YEAR& MOD 400
            MOD100& = YEAR& MOD 100
            MOD4& = YEAR& MOD 4
            IF MOD400& = 0 THEN
                DAYS& = 29
            ELSEIF MOD100& = 0 THEN
                DAYS& = 28
            ELSEIF MOD4& = 0 THEN
                DAYS& = 29
            ELSE
                DAYS& = 28
            END IF
        END IF

END SUB

'*********************************************************************
'*  CALCULATE THE DAY OF WEEK
'*********************************************************************
SUB Dayofweek(YEAR&,MONTH&,DAY&,DOW&)
    DIM fudgefactor(1 TO 12) AS LONG
    fudgefactor(1) = 0
    fudgefactor(2) = 3
    fudgefactor(3) = 2
    fudgefactor(4) = 5
    fudgefactor(5) = 0
    fudgefactor(6) = 3
    fudgefactor(7) = 5
    fudgefactor(8) = 1
    fudgefactor(9) = 4
    fudgefactor(10) = 6
    fudgefactor(11) = 2
    fudgefactor(12) = 4
    DIM holdyyyy&
    DIM century&
    DIM yearmod100&
    DIM adjustments&
    DIM centurymod4&
    DIM bucket&
    DIM leapyears&
    DIM commonyears&
    DIM yearfactor&
    DIM murphysfactor&
    '* print "date = "year&;month&;day&
    '* save the original 4-digit year, so it can be restored
    holdyyyy& = year&
    IF month& < 3 THEN
        year& = year& - 1
    END IF
    century& = INT(year& / 100)
    yearmod100& = year& MOD 100
    '* print "DOW== " year&; century&; yearmod100&; month&; day&
    adjustments = day&
    IF month& > 12 THEN
        month& = 12
    END IF
    adjustments& = adjustments& + fudgefactor(month&)
    centurymod4& = century& MOD 4
    commonyears& = INT(yearmod100& / 4)
    leapyears& = yearmod100& MOD 4     '* Huh?
    yearfactor& = (centurymod4& + commonyears&) * 5
    murphysfactor& = (adjustments& + yearfactor&) + leapyears&
    dow& = (murphysfactor& MOD 7) + 1
    '* restore the original 4-digit year before returning
    year& = holdyyyy&

END SUB

'*********************************************************************
'*  PRINT THE HELP FOR THE "CAL" COMMAND LINE UTILITY
'*********************************************************************
SUB PrintHelp(RC&)
    RC& = 0
    PRINT "Cal displays a simple calendar.  If NO arguments are specified,"
    PRINT "the current month is displayed."
    PRINT
    PRINT "Cal [1752 - 3999] - Display a calendar for any year 1753 to 3999"
    PRINT "Cal [1 - 12] [1753 - 3999] - Display specific month/year calendar"
    PRINT "Cal [/? | -? | -h | help | --help] - Display this HELP information"
    PRINT "Cal [/v | -v | version | --version] - Display VERSION information"


END SUB

'*********************************************************************
'*  PRINT THE "CAL" COMMAND VERSION
'*********************************************************************
SUB PrintVersion(Version$,RC&)
    RC& = 0
    PRINT Version$

END SUB
